	import java.io.*;
	import java.util.*;

	public class LoginModelImpl implements ILoginModel{
		private final File file;
		private final Properties properties;
		private String session;

		public LoginModelImpl(File file) throws IOException{
			this.file = file;
			this.properties = new Properties();

			if (file.exists()){
				this.properties.load(new FileReader(file));
			}
		}

		public String login(String username, String password){
			//normally, a network or database call would be made here
			if ("test".equals(username) && "test".equals(password)){
				return "abc123";
			}
			return null;
		}

		public String getCachedUsername(){
			return properties.getProperty("username");
		}

		public void setCachedUsername(String username){
			properties.setProperty("username", username);
			save();
		}

		public String getCachedPassword(){
			return properties.getProperty("password");
		}

		public void setCachedPassword(String password){
			properties.setProperty("password", password);
			save();
		}

		public boolean getCachedRememberMe(){
			String value = properties.getProperty("rememberMe");
			return (value == null) ? false : Boolean.parseBoolean(value);
		}

		public void setCachedRememberMe(boolean rememberMe){
			properties.setProperty("rememberMe", rememberMe + "");
			save();
		}

		public String getSession(){
			return session;
		}

		public void setSession(String session){
			this.session = session;
		}

		private void save() {
			try {
				properties.store(new FileWriter(file), "");
			} catch (IOException e){
				throw new RuntimeException(e);
			}
		}
	}